<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2007                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************\
 *  Complement pour la publication d'article a partir de l'espace public   *
 *  Pierrick le Feuvre 01/2007 Contact : lefeuvre.pierrick@free.fr         *
 *  Ce complement est bien sur libre et distribue sous licence GNU/GPL.    *
\***************************************************************************/

// Pour utiliser cette balise, vous devez disposer de trois autres fichiers
// - formulaire_redacteur.html (a placer dans votre dossier formulaires)
// - local_fr.php (a placer dans votre dossier ecrire/lang)
// - assembler.php (a placerdans ecrire/public en lieu et place du fichier de meme nom

// ATTENTION

// Ce fichier assembler.php appartient au noyau de SPIP. 
// Lors d'une mise a jour, il faudra a nouveau modifier ce fichier assembler.php
// en y placant la fonction supplmentaire qui y est ajoutee.



if (!defined("_ECRIRE_INC_VERSION")) return;	#securite

include_spip('inc/meta');
include_spip('inc/acces');
include_spip('inc/texte');
include_spip('inc/lang');
include_spip('inc/mail');
include_spip('inc/forum');
include_spip('base/abstract_sql');
spip_connect();

charger_generer_url();

/*******************************/
/* GESTION DU FORMULAIRE REDACTEUR */
/*******************************/

// Contexte du formulaire
function balise_FORMULAIRE_REDACTEUR ($p) {
	return calculer_balise_dynamique($p,'FORMULAIRE_REDACTEUR', array('id_rubrique'));
}

// Verification des arguments (contexte + filtres)
// http://doc.spip.org/@balise_FORMULAIRE_SIGNATURE_stat
function balise_FORMULAIRE_REDACTEUR_stat($args, $filtres) {

	// pas d'id_rubrique => erreur de squelette
	if (!$args[0])
		return erreur_squelette(
			_T('zbug_champ_hors_motif',
				array ('champ' => '#FORMULAIRE_REDACTEUR',
					'motif' => 'RUBRIQUES')), '');
	return $args;
}

// executer la balise
function balise_FORMULAIRE_REDACTEUR_dyn($id_rubrique) {

	// verifier l'identite des posteurs 
	if (!$GLOBALS["auteur_session"]) {
		return array('formulaires/formulaire_redacteur_login', 0,
				array('inscription' => generer_url_public('spip_inscription'),
					'oubli' => generer_url_public('spip_pass')));
	} else {
		// forcer ces valeurs
		$auteur = $GLOBALS['auteur_session']['nom'];
		$email_auteur = $GLOBALS['auteur_session']['email'];
	}

	// Valider l'article a partir de l'appel en retour de mail
	if (_request('ecrire_confirm')) { # _GET
		$reponse = reponse_confirmation_ecrire(_request('ecrire_confirm'));  # calculee plus tot: assembler.php
		
		// On renseigne les champs utiles au cas sou l'auteur souhaite creer un nouvel article
		return array('formulaires/formulaire_redacteur', 0,
			array(
				'reponse' => _T('redacteur_article_publie'),
				'auteur' =>$auteur, 
				'email_auteur' =>$email_auteur, 
				'readonly' => "readonly",
				'url' => $site.'/?rubrique'.$id_rubrique,
				'retour_redacteur' => "!"
			));
		}		
	 else  {
	 	// Tous les autres cas :
		// Appel initial du formulaire
		// Previsualisation
		
		// D'abord, recuperer les elements
		$surtitre = _request('surtitre');
		$titre = _request('titre');
		$soustitre = _request('soustitre');
		$chapo = _request('chapo');
		$texte = _request('texte');
		$auteur = _request('auteur');
		$email_auteur = _request('email_auteur');
		$redacteur_nom_site = _request('redacteur_nom_site');
		$redacteur_url_site = _request('redacteur_url_site');
		$url_page=_request('url_page');
			
		// 1. Enregistrement de l'article, envoi du mail pour confirmation et affichage du message de confirmation d'envoi
		 if (_request('confirmer_redacteur')) {
			# _POST
			$url_retour = self(); // pour le retour, on boucle sur la page
			// Appel de la fonction qui va envoyer le mail et enregistrer l'article (voir plus bas)
			$reponse = reponse_redacteur($id_rubrique,
				$auteur, 
				$email_auteur, 
				$surtitre,
				$titre, 
				$soustitre,
				$chapo,
				$texte,
				$redacteur_nom_site,
				$redacteur_url_site,
				$url_retour
			);
			
			// On affiche le message annoncant l'envoi du mail de confirmation
			// On renseigne l'identite pour le cas ou l'auteur souhaite creer un nouvel article
			return array('formulaires/formulaire_redacteur', 0,
				array(
					'reponse' =>$reponse,
					'auteur' =>$auteur, 
					'email_auteur' =>$email_auteur, 
					'readonly' => "readonly",
					'retour_redacteur' => "!"
			));
		}
		else {
		// 2. Premier affichage du formulaire et/ou previsualisation

			// ne pas mettre '', sinon le squelette n'affichera rien.
			$previsu = ' ';
		
			// au premier appel (pas de Post-var nommee "retour_redacteur")
			// memoriser eventuellement l'URL de retour pour y revenir apres
			// envoi du message ; aux appels suivants, reconduire la valeur.
			// Initialiser aussi l'auteur
			
			//21. Premier appel (pas de previsulaisation)
			if (!$retour_redacteur = rawurldecode(_request('retour_redacteur'))) {
				if ($retour_redacteur = rawurldecode(_request('retour')))
					$retour_redacteur = str_replace('&var_mode=recalcul','',$retour_redacteur);
				else {
					// par defaut, on veut prendre url_forum(), mais elle ne sera connue
					// qu'en sortie, on inscrit donc une valeur absurde ("!")
					$retour_redacteur = "!";
					// sauf si on a passe un parametre en argument (exemple : {#SELF})
					if ($url_param_retour)
						$retour_redacteur = str_replace('&amp;', '&', $url_param_retour);
				}
				if (isset($_COOKIE['spip_forum_user'])
				AND is_array($cookie_user = unserialize($_COOKIE['spip_forum_user']))) {
					$auteur = $cookie_user['nom'];
					$email_auteur = $cookie_user['email'];
				} else {
					$auteur = $GLOBALS['auteur_session']['nom'];
					$email_auteur = $GLOBALS['auteur_session']['email'];
				}
		
			} else { 
			// 22. appels ulterieurs avec previsualisation
	
				if ($afficher_texte != 'non') 
					$previsu = inclure_previsu($surtitre, $titre, $soustitre, $chapo, $texte, $email_auteur, $auteur, $redacteur_url_site, $redacteur_nom_site, $url_page);
		
				$arg = forum_fichier_tmp('');
				
				$securiser_action = charger_fonction('securiser_action', 'inc');
				// on sait que cette fonction est dans le fichier associe
				$hash = calculer_action_auteur("ajout_forum-$arg");
		
				// Poser un cookie pour ne pas retaper les infos invariables
				include_spip('inc/cookie');
				spip_setcookie('spip_forum_user',
					serialize(array('nom' => $auteur,
						'email' => $email_auteur)));
			}
			// pour la chaine de hidden
			$script_hidden = $script = str_replace('&amp;', '&', $script);
			return array('formulaires/formulaire_redacteur', 0,
				array(
					'auteur' => $auteur,
					'readonly' => "readonly",
					'email_auteur' => $email_auteur,
					'redacteur_nom_site' => $redacteur_nom_site,
					'retour_redacteur' => $retour_redacteur,
					'afficher_texte' => $afficher_texte,
					'previsu' => $previsu,
					'texte' => $texte,
					'surtitre' => $surtitre,
					'titre' => $titre,
					'soustitre' => $soustitre,
					'chapo' => $chapo,
					'url' => $url_page, # ce sur quoi on fait le action='...'
					//'url_page' =>  # pour les variables hidden
					'redacteur_url_site' => ($redacteur_url_site ? $redacteur_url_site : "http://"),
					'arg' => $arg,
					'hash' => $hash,
					'nobot' => _request('nobot'),
					'confirmer_redacteur' => 'oui',
					'reponse' =>$reponse
			));
		}
	}
}
// LES FONCTIONS 
// http://doc.spip.org/@inclure_previsu
function inclure_previsu($surtitre, $titre, $soustitre, $chapo, $texte, $email_auteur, $auteur, $redacteur_url_site, $redacteur_nom_site)
{
	$erreur = $bouton = '';
	if (strlen($texte) < 10 AND !$ajouter_mot)
		$erreur = _T('redacteur_attention_dix_caracteres');
	else if (strlen($titre) < 3)
		$erreur = _T('redacteur_attention_trois_caracteres');
	else if (defined('_FORUM_LONGUEUR_MAXI')
	AND _FORUM_LONGUEUR_MAXI > 0
	AND strlen($texte) > _FORUM_LONGUEUR_MAXI)
		$erreur = _T('redacteur_attention_trop_caracteres',
			array(
				'compte' => strlen($texte),
				'max' => _FORUM_LONGUEUR_MAXI
			));
	else
		$bouton = _T('redacteur_article_definitif');

	// supprimer les <form> de la previsualisation
	// (sinon on ne peut pas faire <cadre>...</cadre> dans les forums)
	return preg_replace("@<(/?)f(orm[>[:space:]])@ism",
			    "<\\1no-f\\2",
		inclure_balise_dynamique(array('formulaires/formulaire_redacteur_previsu',
		      0,
		      array(
			'surtitre' => safehtml(typo($surtitre)),
			'titre' => safehtml(typo($titre)),
			'soustitre' => safehtml(typo($soustitre)),
			'email_auteur' => safehtml($email_auteur),
			'auteur' => safehtml(typo($auteur)),
			'chapo' => safehtml(typo($chapo)),
			'texte' => safehtml(propre($texte)),
			'redacteur_url_site' => vider_url($redacteur_url_site),
			'redacteur_nom_site' => safehtml(typo($redacteur_nom_site)),
			'erreur' => $erreur,
			'bouton' => $bouton
			)
					       ),
					 false));
}
// Une securite qui nous protege contre :
// - les doubles validations de forums (derapages humains ou des brouteurs)
// - les abus visant a mettre des forums malgre nous sur un article (??)
// On installe un fichier temporaire dans _DIR_TMP (et pas _DIR_CACHE
// afin de ne pas bugguer quand on vide le cache)
// Le lock est leve au moment de l'insertion en base (inc-messforum)
// Ce systeme n'est pas fonctionnel pour les forums sans previsu (notamment
// si $afficher_texte = 'non')

// DETOURNEMENT de la fonction forum_fichier_temp
// http://doc.spip.org/@forum_fichier_tmp
function forum_fichier_tmp($arg)
{
# astuce : mt_rand pour autoriser les hits simultanes
	while (($alea = time() + @mt_rand()) + intval($arg)
	       AND @file_exists($f = _DIR_TMP."forum_$alea.lck"))
	  {};
	spip_touch ($f);

# et maintenant on purge les locks de forums ouverts depuis > 4 h

	if ($dh = @opendir(_DIR_TMP))
		while (($file = @readdir($dh)) !== false)
			if (preg_match('/^forum_([0-9]+)\.lck$/', $file)
			AND (time()-@filemtime(_DIR_TMP.$file) > 4*3600))
				@unlink(_DIR_TMP.$file);
	return $alea;
}




// Retour a l'ecran du lien de confirmation de validation de l article.
// Si ecrire_confirm est non vide, c'est l appel dans public/assembler.php
// pour vider le cache au demarrage afin que le nouvel article apparaisse.
// Sinon, c'est l'execution du formulaire et on retourne le message 
// de confirmation ou d'erreur construit lors de l'appel par assembler.php

// si ecrire_confirm, on change statut article sinon rien
function reponse_confirmation_ecrire($ecrire_confirm) {

	static $confirm = '';
	if (!$ecrire_confirm) return $confirm;

	if (spip_connect()) {
		include_spip('inc/texte');
		include_spip('inc/filtres');
		
		spip_query("UPDATE spip_articles SET statut='publie', date_redac=NOW() WHERE statut='$ecrire_confirm'");
	}
	else {
		$confirm= _T('redacteur_probleme_technique');
	}
}
// http://doc.spip.org/@reponse_signature
function reponse_redacteur($id_rubrique, $auteur, $email_auteur, $surtitre, $titre, $soustitre, $chapo, $texte, $redacteur_nom_site, $redacteur_url_site, $url_page) {

	if (!spip_connect()) return _T('redacteur_probleme_technique');

	include_spip('inc/texte');
	include_spip('inc/filtres');
	include_spip('inc/mail');
	
	// Repris de inc_forum_insert
	// Antispam : si 'nobot' a ete renseigne, ca ne peut etre qu'un bot
	if (strlen(_request('nobot'))) {
		//tracer_erreur_forum('champ interdit (nobot) rempli'); COMPLEMENT RESTANT A DEVELOPPER POUR POUVOIR TRACER
		return $retour_forum; # echec silencieux du POST
	}
	else {
		
		$passw = test_pass();
		$site=$GLOBALS['meta']['adresse_site'];
		$url =  parametre_url($site.'/'.$url_page,	'ecrire_confirm',$passw);
		$messagex = _T('redacteur_mail_confirmation', array('titre' => $titre, 'nom_email' => $auteur, 'nom_site' => $redacteur_nom_site, 'url_site' => $redacteur_url_site, 'chapo' => $chapo.'...', 'url' => $url));
		if (envoyer_mail($email_auteur, _T('redacteur_confirmation')." ".$titre, $messagex)) {
			$row = spip_fetch_array(spip_query("SELECT id_secteur FROM spip_rubriques WHERE id_rubrique='$id_rubrique'"));
			$id_secteur = $row['id_secteur'];

			$id_article = spip_abstract_insert('spip_articles', "(id_rubrique, id_secteur, surtitre, titre, soustitre, chapo, texte, nom_site, url_site, date, statut, accepter_forum)", "('$id_rubrique', '$id_secteur', '$surtitre', '$titre', '$soustitre', '$chapo', '$texte', '$redacteur_nom_site', '$redacteur_url_site',  NOW(), '$passw', 'abo')");
			spip_abstract_insert('spip_auteurs_articles', "(id_auteur,id_article)", "('" . $GLOBALS['auteur_session']['id_auteur'] . "','$id_article')");

			
			include_spip('inc/modifier');
			revision_signature($id_article, array(
				'auteur' => $auteur,
				'ad_email' => $email_auteur
				//'message' => $chapo.'...'

			));
			$texto = _T('redacteur_envoi_mail_confirmation');
		}
		else {
			$texto = _T('redacteur_probleme_technique');
		}
	
	//spip_release_lock($lock);
	return $texto;
	}
}


// http://doc.spip.org/@test_pass
function test_pass() {
	include_spip('inc/acces');
	for (;;) {
		$passw = creer_pass_aleatoire();
		if (!spip_num_rows(spip_abstract_select('statut', 'spip_articles', "statut='$passw'")))
			return $passw;
	}

}

?>
